<?php

namespace Drupal\decoupled_toolbox\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 */
class DecoupledToolboxSettingsForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'decoupled_toolbox_settings';
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'decoupled_toolbox.settings',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('decoupled_toolbox.settings');
    $form['version'] = [
      '#type' => 'number',
      '#min' => 1.00,
      '#step' => 0.1,
      '#title' => t('Version'),
      '#default_value' => $config->get('version') ?? 1.0,
      '#description' => $this->t('Version of api. The version is automatically increment when you change your display.'),
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    // Retrieve the configuration
    $this->configFactory->getEditable('decoupled_toolbox.settings')
      ->set('version', $form_state->getValue('version'))
      ->save();
    parent::submitForm($form, $form_state);
  }

}
